"use strict";

const _require = require('gatsby-source-graphql/gatsby-node'),
      sourceNodes = _require.sourceNodes;

exports.sourceNodes = sourceNodes;

exports.onCreateWebpackConfig = ({
  actions,
  getConfig
}) => {
  const config = getConfig();

  const traverseRule = rule => {
    if (rule.oneOf && Array.isArray(rule.oneOf)) {
      return Object.assign({}, rule, {
        oneOf: rule.oneOf.map(traverseRule)
      });
    }

    if (rule.use && Array.isArray(rule.use)) {
      rule.use.forEach(ruleUse => {
        if (ruleUse.loader && ruleUse.loader.indexOf(`gatsby/dist/utils/babel-loader.js`) >= 0) {
          ruleUse.loader = require.resolve(`gatsby-source-graphql-universal/babel-loader.js`);
        }
      });
    }

    return rule;
  };

  config.module.rules = config.module.rules.map(traverseRule);
  actions.replaceWebpackConfig(config);
};